package utils

import (
	"encoding/json"

	"clickandjoin.app/serversenteventsserver/modules/structs"
	gocnjhelper "git.clickandjoin.umbach.dev/ClickandJoin/go-cnj-helper"
)

func MarshalMessage(message any) (marshaledMessage []byte, err error) {
	marshaledMessage, err = json.Marshal(message)

	if err != nil {
		gocnjhelper.LogErrorf("Failed to marshal send message, err: %s", err)
		return nil, err
	}

	return marshaledMessage, nil
}

func UnmarshalReceivedMessage(body []byte, receivedMessage *structs.ReceivedMessage) error {
	err := json.Unmarshal(body, &receivedMessage)

	if err != nil {
		gocnjhelper.LogErrorf("Failed to unmarshal received message, err: %s", err)
		return err
	}

	return nil
}
